/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Event.xs. Do not edit this file, edit Event.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Event.xs"
/* -*- C -*- sometimes */

#define MIN_PERL_DEFINE 1

#ifdef __cplusplus
extern "C" {
#endif

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#ifdef __cplusplus
}
#endif

#include "ppport.h"

/* This is unfortunately necessary for the 5.005_0x series. */
#if PERL_REVISION == 5 && PERL_VERSION <= 5 && PERL_SUBVERSION < 53
#  define PL_vtbl_uvar vtbl_uvar
#  define PL_sig_name sig_name
#  define whichsig Perl_whichsig   /* ? */
#endif

/* lexical warnings -- waiting for appropriate magic from
   paul.marquess@bt.com */
#if 0
static void Event_warn(const char* pat, ...) {
    dTHX;
    va_list args;
    va_start(args, pat);
    if (!ckWARN_d(WARN_ALL))
	return;
    Perl_vwarner(aTHX_ WARN_ALL, pat, &args);
    va_end(args);
}

#  undef warn
#  define warn Event_warn
#endif

#if 1
#ifdef warn
#  undef warn
#endif
#define warn Event_warn

static void Event_warn(const char* pat, ...) {
    STRLEN n_a;
    dSP;
    SV *msg;
    va_list args;
    /* perl_require_pv("Carp.pm");     Couldn't possibly be unloaded.*/
    va_start(args, pat);
    msg = sv_newmortal();
    sv_vsetpvfn(msg, pat, strlen(pat), &args, Null(SV**), 0, 0);
    va_end(args);
    SvREADONLY_on(msg);
    PUSHMARK(SP);
    XPUSHs(msg);
    PUTBACK;
    perl_call_pv("Carp::carp", G_DISCARD);
}
#endif

#ifdef croak
#  undef croak
#endif
#define croak Event_croak

static void Event_croak(const char* pat, ...) {
    STRLEN n_a;
    dSP;
    SV *msg;
    va_list args;
    /* perl_require_pv("Carp.pm");     Couldn't possibly be unloaded.*/
    va_start(args, pat);
    msg = sv_newmortal();
    sv_vsetpvfn(msg, pat, strlen(pat), &args, Null(SV**), 0, 0);
    va_end(args);
    SvREADONLY_on(msg);
    PUSHMARK(SP);
    XPUSHs(msg);
    PUTBACK;
    perl_call_pv("Carp::croak", G_DISCARD);
    PerlIO_puts(PerlIO_stderr(), "panic: Carp::croak failed\n");
    (void)PerlIO_flush(PerlIO_stderr());
    my_failure_exit();
}

#ifdef WIN32
#   include <fcntl.h>
#endif

#if defined(HAS_POLL)
# include <poll.h>

/*
	Many operating systems claim to support poll yet they
	actually emulate it with select.  c/unix.c supports
	either poll or select but it doesn't know which one to
	use.  Here we try to detect if we have a native poll
	implementation.  If we do, we use it.  Otherwise,
	select is assumed.
*/

# ifndef POLLOUT
#  undef HAS_POLL
# endif
# ifndef POLLWRNORM
#  undef HAS_POLL
# endif
# ifndef POLLWRBAND
#  undef HAS_POLL
# endif
#endif

/* Is time() portable everywhere?  Hope so!  XXX */

static NV fallback_NVtime()
{ return time(0); }

#include "Event.h"

/* The following is for very simplistic memory leak detection. */

#define MAX_MEMORYCOUNT 20
static int MemoryCount[MAX_MEMORYCOUNT];
static void dbg_count_memory(int id, int cnt) {
    assert(id >= 0 && id < MAX_MEMORYCOUNT);
    MemoryCount[id] += cnt;
}

#if EVENT_MEMORY_DEBUG
#  define EvNew(id, ptr, size, type) dbg_count_memory(id,1); New(0,ptr,size,type)
#  define EvFree(id, ptr) STMT_START { dbg_count_memory(id,-1); safefree(ptr); } STMT_END
#else
#  define EvNew(x, ptr, size, type) New(0,ptr,size,type)
#  define EvFree(id, ptr) safefree(ptr)
#endif

static int LoopLevel, ExitLevel;
static int ActiveWatchers=0; /* includes WaACTIVE + queued events */
static int WarnCounter=16; /*XXX nuke */
static SV *DebugLevel;
static SV *Eval;
static pe_event_stats_vtbl Estat;

/* IntervalEpsilon should be equal to the clock's sleep resolution
   (poll or select) times two.  It probably needs to be bigger if you turn
   on lots of debugging?  Can determine this dynamically? XXX */
static NV IntervalEpsilon = 0.0002;
static int TimeoutTooEarly=0;

static struct EventAPI api;
#define NVtime() (*api.NVtime)()

static int pe_sys_fileno(SV *sv, char *context);

static void queueEvent(pe_event *ev);
static void dequeEvent(pe_event *ev);

static void pe_watcher_cancel(pe_watcher *ev);
static void pe_watcher_suspend(pe_watcher *ev);
static void pe_watcher_resume(pe_watcher *ev);
static void pe_watcher_now(pe_watcher *ev);
static void pe_watcher_start(pe_watcher *ev, int repeat);
static void pe_watcher_stop(pe_watcher *ev, int cancel_events);
static char*pe_watcher_on(pe_watcher *wa, int repeat);
static void pe_watcher_off(pe_watcher *wa);

/* The newHVhv in perl seems to mysteriously break in some cases.  Here
   is a simple and safe (but maybe slow) implementation. */

#ifdef newHVhv
# undef newHVhv
#endif
#define newHVhv event_newHVhv

static HV *event_newHVhv(HV *ohv) {
    register HV *hv = newHV();
    register HE *entry;
    hv_iterinit(ohv);		/* NOTE: this resets the iterator */
    while (entry = hv_iternext(ohv)) {
	hv_store(hv, HeKEY(entry), HeKLEN(entry), 
		SvREFCNT_inc(HeVAL(entry)), HeHASH(entry));
    }
    return hv;
}

static void pe_watcher_STORE_FALLBACK(pe_watcher *wa, SV *svkey, SV *nval)
{
    if (!wa->FALLBACK)
	wa->FALLBACK = newHV();
    hv_store_ent(wa->FALLBACK, svkey, SvREFCNT_inc(nval), 0);
}

/***************** STATS */
static int StatsInstalled=0;
static void pe_install_stats(pe_event_stats_vtbl *esvtbl) {
    ++StatsInstalled;
    Copy(esvtbl, &Estat, 1, pe_event_stats_vtbl);
    Estat.on=0;
}
static void pe_collect_stats(int yes) {
    if (!StatsInstalled)
	croak("collect_stats: no event statistics are available");
    Estat.on = yes;
}

#ifdef HAS_GETTIMEOFDAY
NV null_loops_per_second(int sec)
{
	/*
	  This should be more realistic.  It is used to normalize
	  the benchmark against some theoretical perfect event loop.
	*/
	struct timeval start_tm, done_tm;
	NV elapse;
	unsigned count=0;
	int fds[2];
	if (pipe(fds) != 0) croak("pipe");
	gettimeofday(&start_tm, 0);
	do {
#ifdef HAS_POLL
	  struct pollfd map[2];
	  Zero(map, 2, struct pollfd);
	  map[0].fd = fds[0];
	  map[0].events = POLLIN | POLLOUT;
	  map[0].revents = 0;
	  map[1].fd = fds[1];
	  map[1].events = POLLIN | POLLOUT;
	  map[1].revents = 0;
	  poll(map, 2, 0);
#elif defined(HAS_SELECT)
	  struct timeval null;
	  fd_set rfds, wfds, efds;
	  FD_ZERO(&rfds);
	  FD_ZERO(&wfds);
	  FD_ZERO(&efds);
	  FD_SET(fds[0], &rfds);
	  FD_SET(fds[0], &wfds);
	  FD_SET(fds[1], &rfds);
	  FD_SET(fds[1], &wfds);
	  null.tv_sec = 0;
	  null.tv_usec = 0;
	  select(3,&rfds,&wfds,&efds,&null);
#else
#  error
#endif
	  ++count;
	  gettimeofday(&done_tm, 0);
	  elapse = (done_tm.tv_sec - start_tm.tv_sec +
		    (done_tm.tv_usec - start_tm.tv_usec) / 1000000);
	} while(elapse < sec);
	close(fds[0]);
	close(fds[1]);
return count/sec;
}
#else /* !HAS_GETTIMEOFDAY */
NV null_loops_per_second(int sec)
{ croak("sorry, gettimeofday is not available"); }
#endif


#include "typemap.c"
#include "timeable.c"
#include "hook.c"
#include "ev.c"
#include "watcher.c"
#include "idle.c"
#include "timer.c"
#include "io.c"
#include "unix.c"
#include "var.c"
#include "signal.c"
#include "tied.c"
#include "group.c"
#include "generic.c"
#include "queue.c"

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 297 "Event.c"

XS(XS_Event__add_hook); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__add_hook)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::_add_hook", "type, code");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	type = (char *)SvPV_nolen(ST(0));
	SV *	code = ST(1);
#line 349 "Event.xs"
	pe_add_hook(type, 1, code, 0);
	/* would be nice to return new pe_qcallback* XXX */
#line 316 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__timeout_too_early); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__timeout_too_early)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::_timeout_too_early", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 355 "Event.xs"
	RETVAL = TimeoutTooEarly;
	TimeoutTooEarly=0;
#line 339 "Event.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Event__memory_counters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__memory_counters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::_memory_counters", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 363 "Event.xs"
{
#ifdef EVENT_MEMORY_DEBUG
    int xx;
    for (xx=0; xx < MAX_MEMORYCOUNT; xx++)
	XPUSHs(sv_2mortal(newSViv(MemoryCount[xx])));
#endif
}
#line 368 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__incr_looplevel); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__incr_looplevel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::_incr_looplevel", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 374 "Event.xs"
     ++LoopLevel;
     ++ExitLevel;
#line 392 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__decr_looplevel); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__decr_looplevel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::_decr_looplevel", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 380 "Event.xs"
     --LoopLevel;
#line 415 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event_unloop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_unloop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 385 "Event.xs"
     pe_unloop(items? ST(0) : &PL_sv_undef);
#line 434 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event_unloop_all); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_unloop_all)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 390 "Event.xs"
     pe_unloop_all(items? ST(0) : &PL_sv_undef);
#line 452 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event_cache_time_api); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_cache_time_api)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::cache_time_api", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	bool	RETVAL;
#line 395 "Event.xs"
	SV **svp = hv_fetch(PL_modglobal, "Time::NVtime", 12, 0);
	if (!svp || !*svp || !SvIOK(*svp))
	    XSRETURN_NO;
	api.NVtime = INT2PTR(NV(*)(), SvIV(*svp));
	XSRETURN_YES;
#line 477 "Event.c"
    }
    XSRETURN(1);
}


XS(XS_Event_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::time", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	RETVAL;
	dXSTARG;
#line 405 "Event.xs"
	RETVAL = NVtime();
#line 499 "Event.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Event_sleep); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_sleep)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::sleep", "tm");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	tm = (NV)SvNV(ST(0));
#line 414 "Event.xs"
	pe_sys_sleep(tm);
#line 521 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event_null_loops_per_second); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_null_loops_per_second)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::null_loops_per_second", "sec");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	sec = (int)SvIV(ST(0));
	NV	RETVAL;
	dXSTARG;

	RETVAL = null_loops_per_second(sec);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Event_all_watchers); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_all_watchers)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::all_watchers", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 424 "Event.xs"
	pe_watcher *ev;
	if (!AllWatchers.next)
	  return;
	ev = (pe_watcher*) AllWatchers.next->self;
	while (ev) {
	  XPUSHs(watcher_2sv(ev));
	  ev = (pe_watcher*) ev->all.next->self;
	}
#line 573 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event_all_idle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_all_idle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::all_idle", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 437 "Event.xs"
	pe_watcher *ev;
	if (!Idle.prev)
	  return;
	ev = (pe_watcher*) Idle.prev->self;
	while (ev) {
	  XPUSHs(watcher_2sv(ev));
	  ev = (pe_watcher*) ((pe_idle*)ev)->iring.prev->self;
	}
#line 603 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event_all_running); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_all_running)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::all_running", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 450 "Event.xs"
	int fx;
	for (fx = CurCBFrame; fx >= 0; fx--) {
	  pe_watcher *ev = (CBFrame + fx)->ev->up; /* XXX */
	  XPUSHs(watcher_2sv(ev));
	  if (GIMME_V != G_ARRAY)
	    break;
	}
#line 632 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event_queue); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_queue)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 462 "Event.xs"
	pe_watcher *wa;
	pe_event *ev;
#line 654 "Event.c"
#line 465 "Event.xs"
	wa = (pe_watcher*) sv_2watcher(ST(0));
	if (items == 1) {
	    ev = (*wa->vtbl->new_event)(wa);
	    ++ev->hits;
	}
	else if (items == 2) {
	  if (SvNIOK(ST(1))) {
	    ev = (*wa->vtbl->new_event)(wa);
	    ev->hits += SvIV(ST(1));
	  }
	  else {
	    ev = (pe_event*) sv_2event(ST(1));
	    if (ev->up != wa)
	      croak("queue: event doesn't match watcher");
	  }
	}
	queueEvent(ev);
#line 673 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event_one_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_one_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 487 "Event.xs"
	NV maxtm = 60;
	if (items == 1) maxtm = SvNV(ST(0));
	RETVAL = safe_one_event(maxtm);
#line 696 "Event.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Event__loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::_loop", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 496 "Event.xs"
	pe_check_recovery();
	pe_reentry();
        if (!ActiveWatchers)
          warn("Event: loop without active watchers");
	while (ExitLevel >= LoopLevel && ActiveWatchers) {
	  ENTER;
	  SAVETMPS;
	  one_event(60);
	  FREETMPS;
	  LEAVE;
	}
	LEAVE; /* reentry */
#line 728 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event_queue_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_queue_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::queue_pending", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 512 "Event.xs"
	pe_queue_pending();
#line 748 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__empty_queue); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__empty_queue)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::_empty_queue", "prio");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	prio = (int)SvIV(ST(0));
	int	RETVAL;
	dXSTARG;
#line 518 "Event.xs"
	pe_check_recovery();
	pe_reentry();
	while (pe_empty_queue(prio));
	LEAVE; /* reentry */
#line 774 "Event.c"
    }
    XSRETURN(1);
}


XS(XS_Event_queue_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event_queue_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::queue_time", "prio");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	prio = (int)SvIV(ST(0));
#line 527 "Event.xs"
	NV max=0;
	int xx;
	if (prio < 0 || prio >= PE_QUEUES)
	  croak("queue_time(%d) out of domain [0..%d]",
		prio, PE_QUEUES-1);
	for (xx=0; xx <= prio; xx++)
	  if (max < QueueTime[xx]) max = QueueTime[xx];
	XPUSHs(max? sv_2mortal(newSVnv(max)) : &PL_sv_undef);
#line 804 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Event__Io_got); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Event__Io_got)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Event::Io::got", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0));
#line 542 "Event.xs"
	XPUSHs(sv_2mortal(events_mask_2sv(((pe_ioevent*)THIS)->got)));
#line 828 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Event__Dataful_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Event__Dataful_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Event::Dataful::data", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0));
#line 549 "Event.xs"
	XPUSHs(((pe_datafulevent*)THIS)->data);
#line 852 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Event_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Event_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Event::DESTROY", "ref");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	ref = ST(0);
#line 557 "Event.xs"
{
	pe_event *THIS = (pe_event*) sv_2event(ref);
	if (WaDEBUGx(THIS) >= 3) {
	    STRLEN n_a;
	    warn("Event=0x%x '%s' DESTROY SV=0x%x",
		 THIS, SvPV(THIS->up->desc, n_a),
		 THIS->mysv? SvRV(THIS->mysv) : 0);
	}
	(*THIS->vtbl->dtor)(THIS);
}
#line 883 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Event_mom); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Event_mom)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Event::mom", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0));
#line 571 "Event.xs"
	if (--WarnCounter >= 0) warn("'mom' renamed to 'w'");
	XPUSHs(watcher_2sv(THIS->up));
#line 907 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Event_w); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Event_w)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Event::w", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0));
#line 577 "Event.xs"
	XPUSHs(watcher_2sv(THIS->up));
#line 931 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Event_hits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Event_hits)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Event::hits", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0));
#line 582 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->hits)));
#line 955 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Event_prio); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Event_prio)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Event::prio", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0));
#line 587 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->prio)));
#line 979 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::DESTROY", "ref");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	ref = ST(0);
#line 595 "Event.xs"
{
	pe_watcher *THIS = (pe_watcher*) sv_2watcher(ref);
	assert(THIS);
	if (THIS->mysv) {
	    THIS->mysv=0;
	    if (WaCANDESTROY(THIS)) /*mysv*/
		(*THIS->vtbl->dtor)(THIS);
	}
}
#line 1009 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::pending", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 608 "Event.xs"
{
    if (GIMME_V == G_ARRAY) {
	pe_event *ev = (pe_event *) THIS->events.prev->self;
	while (ev) {
	    XPUSHs(event_2sv(ev));
	    ev = (pe_event*) ev->peer.prev->self;
	}
    } else {
	XPUSHs(THIS->events.next->self? &PL_sv_yes : &PL_sv_no);
    }
}
#line 1042 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_again); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_again)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::again", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 623 "Event.xs"
	pe_watcher_start(THIS, 1);
#line 1064 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::start", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 628 "Event.xs"
	pe_watcher_start(THIS, 0);
#line 1085 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::suspend", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 633 "Event.xs"
	if (items == 2) {
	    if (sv_true(ST(1)))
		pe_watcher_suspend(THIS);
	    else
		pe_watcher_resume(THIS);
	} else {
	    warn("Ambiguous use of suspend"); /*XXX*/
	    pe_watcher_suspend(THIS);
	    XSRETURN_YES;
	}
#line 1115 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::resume", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 647 "Event.xs"
	warn("Please use $w->suspend(0) instead of resume"); /* DEPRECATED */
	pe_watcher_resume(THIS);
#line 1137 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::stop", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 653 "Event.xs"
	pe_watcher_stop(THIS, 1);
#line 1158 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_cancel); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_cancel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::cancel", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 658 "Event.xs"
	pe_watcher_cancel(THIS);
#line 1179 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_now); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_now)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::now", "THIS");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 663 "Event.xs"
	pe_watcher_now(THIS);
#line 1200 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Watcher_use_keys); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_use_keys)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::use_keys", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 668 "Event.xs"
#line 1221 "Event.c"
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 669 "Event.xs"
	warn("use_keys is deprecated");
#line 1225 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_is_running); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_is_running)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::is_running", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 674 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->running)));
#line 1249 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_is_active); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_is_active)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::is_active", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 679 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaACTIVE(THIS)));
#line 1274 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_is_suspended); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_is_suspended)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::is_suspended", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 685 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaSUSPEND(THIS)));
#line 1299 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_is_cancelled); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_is_cancelled)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::is_cancelled", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 691 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaCANCELLED(THIS)));
#line 1324 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::cb", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 697 "Event.xs"
	PUTBACK;
	_watcher_callback(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1350 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_cbtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_cbtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::cbtime", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 704 "Event.xs"
	PUTBACK;
	_watcher_cbtime(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1376 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_desc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_desc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::desc", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 711 "Event.xs"
	PUTBACK;
	_watcher_desc(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1402 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_debug); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_debug)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::debug", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 718 "Event.xs"
	PUTBACK;
	_watcher_debug(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1428 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_prio); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_prio)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::prio", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 725 "Event.xs"
	PUTBACK;
	_watcher_priority(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1454 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_reentrant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_reentrant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::reentrant", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 732 "Event.xs"
	PUTBACK;
	_watcher_reentrant(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1480 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_repeat); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_repeat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::repeat", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 739 "Event.xs"
	PUTBACK;
	_watcher_repeat(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1506 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher_max_cb_tm); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher_max_cb_tm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::max_cb_tm", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 746 "Event.xs"
	PUTBACK;
	_watcher_max_cb_tm(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1532 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher__Tied_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher__Tied_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::Tied::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 757 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_tied_allocate(gv_stashsv(clname, 1),
					    SvRV(temple))));
#line 1559 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher__Tied_hard); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher__Tied_hard)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::Tied::hard", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 764 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1585 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher__Tied_at); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher__Tied_at)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::Tied::at", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 771 "Event.xs"
	PUTBACK;
	_tied_at(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1611 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__Watcher__Tied_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Watcher__Tied_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Watcher::Tied::flags", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 778 "Event.xs"
	PUTBACK;
	_tied_flags(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1637 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__idle_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__idle_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::idle::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 789 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_idle_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1664 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__idle_hard); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__idle_hard)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::idle::hard", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 796 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1690 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__idle_max); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__idle_max)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::idle::max", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 803 "Event.xs"
	PUTBACK;
	_idle_max_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1716 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__idle_min); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__idle_min)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::idle::min", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 810 "Event.xs"
	PUTBACK;
	_idle_min_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1742 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__timer_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__timer_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::timer::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 821 "Event.xs"
	XPUSHs(watcher_2sv(pe_timer_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1768 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__timer_at); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__timer_at)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::timer::at", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 827 "Event.xs"
	PUTBACK;
	_timer_at(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1794 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__timer_hard); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__timer_hard)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::timer::hard", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 834 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1820 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__timer_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__timer_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::timer::interval", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 841 "Event.xs"
	PUTBACK;
	_timer_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1846 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__io_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__io_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::io::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 852 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_io_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1873 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__io_poll); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__io_poll)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::io::poll", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 859 "Event.xs"
	PUTBACK;
	_io_poll(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1899 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__io_fd); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__io_fd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::io::fd", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 866 "Event.xs"
	PUTBACK;
	_io_handle(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1925 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__io_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__io_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::io::timeout", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 873 "Event.xs"
	PUTBACK;
	_io_timeout(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1951 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__io_timeout_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__io_timeout_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::io::timeout_cb", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 880 "Event.xs"
	PUTBACK;
	_io_timeout_cb(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1977 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__var_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__var_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::var::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 891 "Event.xs"
	XPUSHs(watcher_2sv(pe_var_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 2003 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__var_var); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__var_var)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::var::var", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 897 "Event.xs"
	PUTBACK;
	_var_variable(THIS, items == 2? ST(1) : 0); /* don't mortalcopy!! */
	SPAGAIN;
#line 2029 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__var_poll); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__var_poll)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::var::poll", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 904 "Event.xs"
	PUTBACK;
	_var_events(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2055 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__signal_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__signal_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::signal::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 915 "Event.xs"
	XPUSHs(watcher_2sv(pe_signal_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 2081 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__signal_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__signal_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::signal::signal", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 921 "Event.xs"
	PUTBACK;
	_signal_signal(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2107 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__group_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__group_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::group::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 932 "Event.xs"
     XPUSHs(watcher_2sv(pe_group_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 2133 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__group_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__group_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::group::timeout", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 938 "Event.xs"
	PUTBACK;
	_group_timeout(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2159 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__group_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__group_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::group::add", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 945 "Event.xs"
	PUTBACK;
	_group_add(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2185 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__group_del); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__group_del)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::group::del", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 952 "Event.xs"
	PUTBACK;
	_group_del(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2211 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__generic_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__generic_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::generic::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 963 "Event.xs"
     XPUSHs(watcher_2sv(pe_generic_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 2237 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__generic_source); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__generic_source)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::generic::source", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0));
#line 969 "Event.xs"
	PUTBACK;
	_generic_source(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2263 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__generic__Source_allocate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__generic__Source_allocate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::generic::Source::allocate", "clname, temple");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0);
	SV *	temple = ST(1);
#line 980 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(genericsrc_2sv(pe_genericsrc_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 2290 "Event.c"
	PUTBACK;
	return;
    }
}


XS(XS_Event__generic__Source_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__generic__Source_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::generic::Source::DESTROY", "ref");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	ref = ST(0);
#line 988 "Event.xs"
{
	pe_genericsrc_dtor(sv_2genericsrc(ref));
}
#line 2314 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__generic__Source_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__generic__Source_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::generic::Source::event", "THIS, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_genericsrc *	THIS = (pe_genericsrc *) sv_2genericsrc(ST(0));
#line 995 "Event.xs"
	pe_genericsrc_event(THIS,
		items >= 2 ? sv_mortalcopy(ST(1)) : &PL_sv_undef);
#line 2338 "Event.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Event); /* prototype to pass -Wmissing-prototypes */
XS(boot_Event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Event::_add_hook", XS_Event__add_hook, file);
        newXS("Event::_timeout_too_early", XS_Event__timeout_too_early, file);
        newXS("Event::_memory_counters", XS_Event__memory_counters, file);
        newXS("Event::_incr_looplevel", XS_Event__incr_looplevel, file);
        newXS("Event::_decr_looplevel", XS_Event__decr_looplevel, file);
        newXS("Event::unloop", XS_Event_unloop, file);
        newXS("Event::unloop_all", XS_Event_unloop_all, file);
        newXS("Event::cache_time_api", XS_Event_cache_time_api, file);
        newXSproto("Event::time", XS_Event_time, file, "");
        newXSproto("Event::sleep", XS_Event_sleep, file, "$");
        newXS("Event::null_loops_per_second", XS_Event_null_loops_per_second, file);
        newXSproto("Event::all_watchers", XS_Event_all_watchers, file, "");
        newXSproto("Event::all_idle", XS_Event_all_idle, file, "");
        newXSproto("Event::all_running", XS_Event_all_running, file, "");
        newXSproto("Event::queue", XS_Event_queue, file, "$;$");
        newXSproto("Event::one_event", XS_Event_one_event, file, ";$");
        newXS("Event::_loop", XS_Event__loop, file);
        newXS("Event::queue_pending", XS_Event_queue_pending, file);
        newXS("Event::_empty_queue", XS_Event__empty_queue, file);
        newXS("Event::queue_time", XS_Event_queue_time, file);
        newXS("Event::Event::Io::got", XS_Event__Event__Io_got, file);
        newXS("Event::Event::Dataful::data", XS_Event__Event__Dataful_data, file);
        newXS("Event::Event::DESTROY", XS_Event__Event_DESTROY, file);
        newXS("Event::Event::mom", XS_Event__Event_mom, file);
        newXS("Event::Event::w", XS_Event__Event_w, file);
        newXS("Event::Event::hits", XS_Event__Event_hits, file);
        newXS("Event::Event::prio", XS_Event__Event_prio, file);
        newXS("Event::Watcher::DESTROY", XS_Event__Watcher_DESTROY, file);
        newXS("Event::Watcher::pending", XS_Event__Watcher_pending, file);
        newXS("Event::Watcher::again", XS_Event__Watcher_again, file);
        newXS("Event::Watcher::start", XS_Event__Watcher_start, file);
        newXS("Event::Watcher::suspend", XS_Event__Watcher_suspend, file);
        newXS("Event::Watcher::resume", XS_Event__Watcher_resume, file);
        newXS("Event::Watcher::stop", XS_Event__Watcher_stop, file);
        newXS("Event::Watcher::cancel", XS_Event__Watcher_cancel, file);
        newXS("Event::Watcher::now", XS_Event__Watcher_now, file);
        newXS("Event::Watcher::use_keys", XS_Event__Watcher_use_keys, file);
        newXS("Event::Watcher::is_running", XS_Event__Watcher_is_running, file);
        newXS("Event::Watcher::is_active", XS_Event__Watcher_is_active, file);
        newXS("Event::Watcher::is_suspended", XS_Event__Watcher_is_suspended, file);
        newXS("Event::Watcher::is_cancelled", XS_Event__Watcher_is_cancelled, file);
        newXS("Event::Watcher::cb", XS_Event__Watcher_cb, file);
        newXS("Event::Watcher::cbtime", XS_Event__Watcher_cbtime, file);
        newXS("Event::Watcher::desc", XS_Event__Watcher_desc, file);
        newXS("Event::Watcher::debug", XS_Event__Watcher_debug, file);
        newXS("Event::Watcher::prio", XS_Event__Watcher_prio, file);
        newXS("Event::Watcher::reentrant", XS_Event__Watcher_reentrant, file);
        newXS("Event::Watcher::repeat", XS_Event__Watcher_repeat, file);
        newXS("Event::Watcher::max_cb_tm", XS_Event__Watcher_max_cb_tm, file);
        newXS("Event::Watcher::Tied::allocate", XS_Event__Watcher__Tied_allocate, file);
        newXS("Event::Watcher::Tied::hard", XS_Event__Watcher__Tied_hard, file);
        newXS("Event::Watcher::Tied::at", XS_Event__Watcher__Tied_at, file);
        newXS("Event::Watcher::Tied::flags", XS_Event__Watcher__Tied_flags, file);
        newXS("Event::idle::allocate", XS_Event__idle_allocate, file);
        newXS("Event::idle::hard", XS_Event__idle_hard, file);
        newXS("Event::idle::max", XS_Event__idle_max, file);
        newXS("Event::idle::min", XS_Event__idle_min, file);
        newXS("Event::timer::allocate", XS_Event__timer_allocate, file);
        newXS("Event::timer::at", XS_Event__timer_at, file);
        newXS("Event::timer::hard", XS_Event__timer_hard, file);
        newXS("Event::timer::interval", XS_Event__timer_interval, file);
        newXS("Event::io::allocate", XS_Event__io_allocate, file);
        newXS("Event::io::poll", XS_Event__io_poll, file);
        newXS("Event::io::fd", XS_Event__io_fd, file);
        newXS("Event::io::timeout", XS_Event__io_timeout, file);
        newXS("Event::io::timeout_cb", XS_Event__io_timeout_cb, file);
        newXS("Event::var::allocate", XS_Event__var_allocate, file);
        newXS("Event::var::var", XS_Event__var_var, file);
        newXS("Event::var::poll", XS_Event__var_poll, file);
        newXS("Event::signal::allocate", XS_Event__signal_allocate, file);
        newXS("Event::signal::signal", XS_Event__signal_signal, file);
        newXS("Event::group::allocate", XS_Event__group_allocate, file);
        newXS("Event::group::timeout", XS_Event__group_timeout, file);
        newXS("Event::group::add", XS_Event__group_add, file);
        newXS("Event::group::del", XS_Event__group_del, file);
        newXS("Event::generic::allocate", XS_Event__generic_allocate, file);
        newXS("Event::generic::source", XS_Event__generic_source, file);
        newXS("Event::generic::Source::allocate", XS_Event__generic__Source_allocate, file);
        newXS("Event::generic::Source::DESTROY", XS_Event__generic__Source_DESTROY, file);
        newXS("Event::generic::Source::event", XS_Event__generic__Source_event, file);

    /* Initialisation Section */

#line 288 "Event.xs"
  LoopLevel = ExitLevel = 0;
  DebugLevel = SvREFCNT_inc(perl_get_sv("Event::DebugLevel", 1));
  Eval = SvREFCNT_inc(perl_get_sv("Event::Eval", 1));
  Estat.on=0;
  boot_timeable();
  boot_hook();
  boot_pe_event();
  boot_pe_watcher();
  boot_idle();
  boot_timer();
  boot_io();
  boot_devpoll();
  boot_var();
  boot_tied();
  boot_signal();
  boot_group();
  boot_generic();
  boot_queue();
  {
      SV *apisv;
      api.Ver = EventAPI_VERSION;
      api.start = pe_watcher_start;
      api.queue = queueEvent;
      api.now = pe_watcher_now;
      api.suspend = pe_watcher_suspend;
      api.resume = pe_watcher_resume;
      api.stop = pe_watcher_stop;
      api.cancel = pe_watcher_cancel;
      api.tstart = pe_timeable_start;
      api.tstop  = pe_timeable_stop;
      api.NVtime = fallback_NVtime;
      api.new_idle =   (pe_idle*  (*)(HV*,SV*))    pe_idle_allocate;
      api.new_timer =  (pe_timer* (*)(HV*,SV*))    pe_timer_allocate;
      api.new_io =     (pe_io*    (*)(HV*,SV*))    pe_io_allocate;
      api.new_var =    (pe_var*   (*)(HV*,SV*))    pe_var_allocate;
      api.new_signal = (pe_signal*(*)(HV*,SV*))    pe_signal_allocate;
      api.add_hook = capi_add_hook;
      api.cancel_hook = pe_cancel_hook;
      api.install_stats = pe_install_stats;
      api.collect_stats = pe_collect_stats;
      api.AllWatchers = &AllWatchers;
      api.watcher_2sv = watcher_2sv;
      api.sv_2watcher = sv_2watcher;
      api.event_2sv = event_2sv;
      api.sv_2event = sv_2event;
      api.unloop = pe_unloop;
      api.unloop_all = pe_unloop_all;
      api.sv_2interval = sv_2interval;
      api.events_mask_2sv = events_mask_2sv;
      api.sv_2events_mask = sv_2events_mask;

      apisv = perl_get_sv("Event::API", 1);
      sv_setiv(apisv, (IV)&api);
      SvREADONLY_on(apisv);
  }

#line 2501 "Event.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

